<template>
	<list-search @searchData="searchData" @clearData="clearData" :search_params="commomParams.search"></list-search>
	<a-c-operation @refresh="clearData">
	
	</a-c-operation>
	<a-c-table :data="commomParams.table.data" :columns="commomParams.table.columns" :pagination="commomParams.page"
		@page="getPage" :loading="loading">
		<template #hide_ad="{ record }">
				<a-tag color="green" v-if="record.hide_ad == 2">显示</a-tag>
				<a-tag color="red"  v-if="record.hide_ad == 1">隐藏</a-tag>
		</template>
		
		<template #default="{ record }">
			<a-row :gutter="10">
				<a-col><a-button type="primary" size="small" primary @click="edit(record)">编辑</a-button></a-col>
				<a-popconfirm title="是否删除该广告?" @confirm="delOneRole(record.id)">
					<a-col><a-button type="primary" size="small" danger>删除</a-button></a-col>
				</a-popconfirm>
			</a-row>
		</template>
	</a-c-table>
	<list-add :edit_record="edit_record" @successAdd="successAdd" @closeAdd="closeAdd"></list-add>
</template>

<script lang="ts" setup>
	import { ref, onMounted, watch, computed } from 'vue';
	import ListSearch from '@/views/advertisement/putin/search/index.vue';
	import ListAdd from '@/views/advertisement/putin/add/add.vue';
	import { GetAdvertscheduleList, PostAdvertscheduleDel } from '@/apis/models';
	import { useCommon } from '@/hooks/useCommon';
	import { cols } from '@/views/advertisement/putin/columns';
	import { message } from 'ant-design-vue';
	let { store, commomParams, showModal, showOtherModal1 } = useCommon();
	let loading = ref<Boolean>(true);
	onMounted(() => {
		commomParams.value.search.hide_ad = 0;
		getData(commomParams.value.search);
	})

	const searchData = (data : object) => {
		commomParams.value.search = data
		getData();
	}

	const clearData = (data : object) => {
		commomParams.value.search = {
			page: 1,
			pagesize: 10,
			sort: 'id',
			sortby: 'desc',
			keyword: '',
			hide_ad: 0
		}
		getData();
	}


	const getPage = (data : object) => {
		commomParams.value.search.page = data.current;
		commomParams.value.search.pagesize = data.pageSize;
		getData();
	}
	const getData = async () => {
		try {
			loading.value = true;
			let res = await GetAdvertscheduleList(commomParams.value.search);
			loading.value = false;
			commomParams.value.table.data = res.data.advertschedules;
			commomParams.value.table.columns = cols;
			commomParams.value.page = {
				current: commomParams.value.search.page,
				pageSize: commomParams.value.search.pagesize,
				total: res.data.total,
				pageSizeOptions: ['10', '20', '30', '40'],
				hideOnSinglePage: false,
				showSizeChanger: true
			};
		} catch {
			loading.value = false;
		}
	}


	// 编辑
	let edit_record = ref<Object>(null)
	const edit = (record : object) => {
		edit_record.value = record;
		showModal()
	}
	const successAdd = () => {
		getData();
	}
	const closeAdd = () => {
		edit_record.value = null;
	}


	// 删除
	const delOneRole = (id : number) => {
		commomParams.value.delRecord = { id: id };
		PostAdvertscheduleDel(commomParams.value.delRecord).then(res => {
			message.success('删除成功');
			getData();
		})
	}
	
	
</script>

<style lang="less" scoped>

</style>